Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/SlaveGroupDao.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/SlaveGroupDao.cs	(revision 12689)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/SlaveGroupDao.cs	(revision 12691)
@@ -45,5 +45,5 @@
     #region IGenericDao<Guid,SlaveGroup> Members
     public SlaveGroup GetById(Guid id) {
-      return Entities.SingleOrDefault(x => x.ResourceId == id);
+      return GetByIdQuery(dataContext, id);
     }
 
@@ -112,5 +112,5 @@
 
     public bool Exists(SlaveGroup entity) {
-      return Table.Contains(entity);
+      return ExistsQuery(dataContext, entity);
     }
 
@@ -119,4 +119,16 @@
     }
     #endregion
+
+    #region Compiled queries
+    private static readonly Func<DataContext, Guid, SlaveGroup> GetByIdQuery =
+      CompiledQuery.Compile((DataContext db, Guid slaveGroupId) =>
+        (from slaveGroup in db.GetTable<Resource>().OfType<SlaveGroup>()
+         where slaveGroup.ResourceId == slaveGroupId
+         select slaveGroup).SingleOrDefault());
+
+    private static readonly Func<DataContext, SlaveGroup, bool> ExistsQuery =
+      CompiledQuery.Compile((DataContext db, SlaveGroup slaveGroup) =>
+        db.GetTable<Resource>().OfType<SlaveGroup>().Contains(slaveGroup));
+    #endregion
   }
 }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/StateLogDao.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/StateLogDao.cs	(revision 12689)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/StateLogDao.cs	(revision 12691)
@@ -26,5 +26,4 @@
 namespace HeuristicLab.Services.Hive.DataAccess.Daos {
   public class StateLogDao : GenericDao<Guid, StateLog> {
-
     private Table<Task> TaskTable {
       get { return DataContext.GetTable<Task>(); }
@@ -34,13 +33,25 @@
 
     public override StateLog GetById(Guid id) {
-      return Table.SingleOrDefault(x => x.StateLogId == id);
+      return GetByIdQuery(DataContext, id);
     }
 
     public StateLog GetLastStateLogFromTask(Task task) {
-      return Table
-        .Where(x => x.TaskId == task.TaskId)
-        .OrderByDescending(x => x.DateTime)
-        .First(x => x.SlaveId != null);
+      return GetLastStateLogFromTaskQuery(DataContext, task);
     }
+
+    #region Compiled queries
+    private static readonly Func<DataContext, Guid, StateLog> GetByIdQuery =
+      CompiledQuery.Compile((DataContext db, Guid stateLogId) =>
+        (from stateLog in db.GetTable<StateLog>()
+         where stateLog.StateLogId == stateLogId
+         select stateLog).SingleOrDefault());
+
+    private static readonly Func<DataContext, Task, StateLog> GetLastStateLogFromTaskQuery =
+      CompiledQuery.Compile((DataContext db, Task task) =>
+        (from stateLog in db.GetTable<StateLog>()
+         where stateLog.TaskId == task.TaskId
+         orderby stateLog.DateTime descending
+         select stateLog).First(x => x.SlaveId != null));
+    #endregion
   }
 }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/TaskDao.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/TaskDao.cs	(revision 12689)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/TaskDao.cs	(revision 12691)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Collections.Generic;
 using System.Data.Linq;
 using System.Linq;
@@ -29,5 +30,5 @@
 
     public override Task GetById(Guid id) {
-      return Table.SingleOrDefault(x => x.TaskId == id);
+      return GetByIdQuery(DataContext, id);
     }
 
@@ -39,4 +40,55 @@
       return Table.Where(x => x.JobId == id);
     }
+    public class TaskPriorityInfo {
+      public Guid JobId { get; set; }
+      public Guid TaskId { get; set; }
+      public int Priority { get; set; }
+    }
+
+    public IEnumerable<TaskPriorityInfo> GetWaitingTasks(Slave slave) {
+      //Originally we checked here if there are parent tasks which should be calculated (with GetParentTasks(resourceIds, count, false);).
+      //Because there is at the moment no case where this makes sense (there don't exist parent tasks which need to be calculated), 
+      //we skip this step because it's wasted runtime
+      return DataContext.ExecuteQuery<TaskPriorityInfo>(GetWaitingTasksQueryString, slave.ResourceId, Enum.GetName(typeof(TaskState), TaskState.Waiting), slave.FreeCores, slave.FreeMemory).ToList();
+    }
+
+    public void UpdateExecutionTime(Guid taskId, double executionTime) {
+      DataContext.ExecuteCommand(UpdateExecutionTimeQuery, executionTime, DateTime.Now, taskId);
+    }
+
+    #region Compiled queries
+    private static readonly Func<DataContext, Guid, Task> GetByIdQuery =
+      CompiledQuery.Compile((DataContext db, Guid taskId) =>
+        (from task in db.GetTable<Task>()
+         where task.TaskId == taskId
+         select task).SingleOrDefault());
+    #endregion
+
+    #region String queries
+    private const string GetWaitingTasksQueryString = @"
+      WITH pr AS (
+        SELECT ResourceId, ParentResourceId
+        FROM [Resource]
+        WHERE ResourceId = {0}
+        UNION ALL
+        SELECT r.ResourceId, r.ParentResourceId
+        FROM [Resource] r JOIN pr ON r.ResourceId = pr.ParentResourceId
+      )
+      SELECT DISTINCT t.TaskId, t.JobId, t.Priority
+      FROM pr JOIN AssignedResources ar ON ar.ResourceId = pr.ResourceId
+          JOIN Task t ON t.TaskId = ar.TaskId
+      WHERE NOT (t.IsParentTask = 1 AND t.FinishWhenChildJobsFinished = 1)
+          AND t.TaskState = {1}
+          AND t.CoresNeeded <= {2}
+          AND t.MemoryNeeded <= {3}
+    ";
+
+    private const string UpdateExecutionTimeQuery = @"
+      UPDATE [Task] 
+         SET ExecutionTimeMs = {0},
+             LastHeartbeat = {1} 
+       WHERE TaskId = {2}
+    ";
+    #endregion
   }
 }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/TaskDataDao.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/TaskDataDao.cs	(revision 12689)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/TaskDataDao.cs	(revision 12691)
@@ -29,6 +29,14 @@
 
     public override TaskData GetById(Guid id) {
-      return Table.SingleOrDefault(x => x.TaskId == id);
+      return GetByIdQuery(DataContext, id);
     }
+
+    #region Compiled queries
+    private static readonly Func<DataContext, Guid, TaskData> GetByIdQuery =
+      CompiledQuery.Compile((DataContext db, Guid taskId) =>
+        (from taskData in db.GetTable<TaskData>()
+         where taskData.TaskId == taskId
+         select taskData).SingleOrDefault());
+    #endregion
   }
 }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/UserPriorityDao.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/UserPriorityDao.cs	(revision 12689)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Daos/UserPriorityDao.cs	(revision 12691)
@@ -29,6 +29,14 @@
 
     public override UserPriority GetById(Guid id) {
-      return Table.SingleOrDefault(x => x.UserId == id);
+      return GetByIdQuery(DataContext, id);
     }
+
+    #region Compiled queries
+    private static readonly Func<DataContext, Guid, UserPriority> GetByIdQuery =
+      CompiledQuery.Compile((DataContext db, Guid userId) =>
+        (from userPriority in db.GetTable<UserPriority>()
+         where userPriority.UserId == userId
+         select userPriority).SingleOrDefault());
+    #endregion
   }
 }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Manager/PersistenceManager.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Manager/PersistenceManager.cs	(revision 12689)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Manager/PersistenceManager.cs	(revision 12691)
@@ -35,92 +35,116 @@
 
     #region Hive daos
+
+    private AssignedResourceDao assignedResourceDao;
     public AssignedResourceDao AssignedResourceDao {
-      get { return new AssignedResourceDao(dataContext); }
-    }
-
+      get { return assignedResourceDao ?? (assignedResourceDao = new AssignedResourceDao(dataContext)); }
+    }
+
+    private DowntimeDao downtimeDao;
     public DowntimeDao DowntimeDao {
-      get { return new DowntimeDao(dataContext); }
-    }
-
+      get { return downtimeDao ?? (downtimeDao = new DowntimeDao(dataContext)); }
+    }
+
+    private JobDao jobDao;
     public JobDao JobDao {
-      get { return new JobDao(dataContext); }
-    }
-
+      get { return jobDao ?? (jobDao = new JobDao(dataContext)); }
+    }
+
+    private JobPermissionDao jobPermissionDao;
     public JobPermissionDao JobPermissionDao {
-      get { return new JobPermissionDao(dataContext); }
-    }
-
+      get { return jobPermissionDao ?? (jobPermissionDao = new JobPermissionDao(dataContext)); }
+    }
+
+    private LifecycleDao lifecycleDao;
     public LifecycleDao LifecycleDao {
-      get { return new LifecycleDao(dataContext); }
-    }
-
+      get { return lifecycleDao ?? (lifecycleDao = new LifecycleDao(dataContext)); }
+    }
+
+    private PluginDao pluginDao;
     public PluginDao PluginDao {
-      get { return new PluginDao(dataContext); }
-    }
-
+      get { return pluginDao ?? (pluginDao = new PluginDao(dataContext)); }
+    }
+
+    private PluginDataDao pluginDataDao;
     public PluginDataDao PluginDataDao {
-      get { return new PluginDataDao(dataContext); }
-    }
-
+      get { return pluginDataDao ?? (pluginDataDao = new PluginDataDao(dataContext)); }
+    }
+
+    private RequiredPluginDao requiredPluginDao;
     public RequiredPluginDao RequiredPluginDao {
-      get { return new RequiredPluginDao(dataContext); }
-    }
-
+      get { return requiredPluginDao ?? (requiredPluginDao = new RequiredPluginDao(dataContext)); }
+    }
+
+    private ResourceDao resourceDao;
     public ResourceDao ResourceDao {
-      get { return new ResourceDao(dataContext); }
-    }
-
+      get { return resourceDao ?? (resourceDao = new ResourceDao(dataContext)); }
+    }
+
+    private ResourcePermissionDao resourcePermissionDao;
     public ResourcePermissionDao ResourcePermissionDao {
-      get { return new ResourcePermissionDao(dataContext); }
-    }
-
+      get { return resourcePermissionDao ?? (resourcePermissionDao = new ResourcePermissionDao(dataContext)); }
+    }
+
+    private SlaveDao slaveDao;
     public SlaveDao SlaveDao {
-      get { return new SlaveDao(dataContext); }
-    }
-
+      get { return slaveDao ?? (slaveDao = new SlaveDao(dataContext)); }
+    }
+
+    private SlaveGroupDao slaveGroupDao;
     public SlaveGroupDao SlaveGroupDao {
-      get { return new SlaveGroupDao(dataContext); }
-    }
-
+      get { return slaveGroupDao ?? (slaveGroupDao = new SlaveGroupDao(dataContext)); }
+    }
+
+    private StateLogDao stateLogDao;
     public StateLogDao StateLogDao {
-      get { return new StateLogDao(dataContext); }
-    }
-
+      get { return stateLogDao ?? (stateLogDao = new StateLogDao(dataContext)); }
+    }
+
+    private TaskDao taskDao;
     public TaskDao TaskDao {
-      get { return new TaskDao(dataContext); }
-    }
-
+      get { return taskDao ?? (taskDao = new TaskDao(dataContext)); }
+    }
+
+    private TaskDataDao taskDataDao;
     public TaskDataDao TaskDataDao {
-      get { return new TaskDataDao(dataContext); }
-    }
-
+      get { return taskDataDao ?? (taskDataDao = new TaskDataDao(dataContext)); }
+    }
+
+    private UserPriorityDao userPriorityDao;
     public UserPriorityDao UserPriorityDao {
-      get { return new UserPriorityDao(dataContext); }
+      get { return userPriorityDao ?? (userPriorityDao = new UserPriorityDao(dataContext)); }
     }
     #endregion
 
     #region HiveStatistics daos
+
+    private DimClientDao dimClientDao;
     public DimClientDao DimClientDao {
-      get { return new DimClientDao(dataContext); }
-    }
-
+      get { return dimClientDao ?? (dimClientDao = new DimClientDao(dataContext)); }
+    }
+
+    private DimJobDao dimJobDao;
     public DimJobDao DimJobDao {
-      get { return new DimJobDao(dataContext); }
-    }
-
+      get { return dimJobDao ?? (dimJobDao = new DimJobDao(dataContext)); }
+    }
+
+    private DimTimeDao dimTimeDao;
     public DimTimeDao DimTimeDao {
-      get { return new DimTimeDao(dataContext); }
-    }
-
+      get { return dimTimeDao ?? (dimTimeDao = new DimTimeDao(dataContext)); }
+    }
+
+    private DimUserDao dimUserDao;
     public DimUserDao DimUserDao {
-      get { return new DimUserDao(dataContext); }
-    }
-
+      get { return dimUserDao ?? (dimUserDao = new DimUserDao(dataContext)); }
+    }
+
+    private FactClientInfoDao factClientInfoDao;
     public FactClientInfoDao FactClientInfoDao {
-      get { return new FactClientInfoDao(dataContext); }
-    }
-
+      get { return factClientInfoDao ?? (factClientInfoDao = new FactClientInfoDao(dataContext)); }
+    }
+
+    private FactTaskDao factTaskDao;
     public FactTaskDao FactTaskDao {
-      get { return new FactTaskDao(dataContext); }
+      get { return factTaskDao ?? (factTaskDao = new FactTaskDao(dataContext)); }
     }
     #endregion
@@ -130,4 +154,8 @@
       if (longRunning) context.CommandTimeout = (int)Settings.Default.LongRunningDatabaseCommandTimeout.TotalSeconds;
       dataContext = context;
+    }
+
+    public PersistenceManager(DataContext dataContext) {
+      this.dataContext = dataContext;
     }
 
@@ -179,7 +207,7 @@
 
     public void Dispose() {
-      if (dataContext != null) {
-        dataContext.Dispose();
-      }
+      //if (dataContext != null) {
+      //  dataContext.Dispose();
+      //}
     }
   }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/HiveService.svc
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/HiveService.svc	(revision 12689)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive.Web/Hive-3.3/HiveService.svc	(revision 12691)
@@ -2,4 +2,4 @@
   Language="C#" 
   Debug="true" 
-  Service="HeuristicLab.Services.Hive.HiveService" 
+  Service="HeuristicLab.Services.Hive.NewHiveService" 
   %>
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Converter.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Converter.cs	(revision 12689)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Converter.cs	(revision 12691)
@@ -150,4 +150,55 @@
     #endregion
 
+    #region Slave
+    public static DT.Slave ToDto(this DA.Slave source) {
+      if (source == null) return null;
+      return new DT.Slave {
+        Id = source.ResourceId,
+        ParentResourceId = source.ParentResourceId,
+        Cores = source.Cores,
+        CpuSpeed = source.CpuSpeed,
+        FreeCores = source.FreeCores,
+        FreeMemory = source.FreeMemory,
+        IsAllowedToCalculate = source.IsAllowedToCalculate,
+        Memory = source.Memory,
+        Name = source.Name,
+        SlaveState = source.SlaveState.ToDto(),
+        CpuArchitecture = source.CpuArchitecture.ToDto(),
+        OperatingSystem = source.OperatingSystem,
+        LastHeartbeat = source.LastHeartbeat,
+        CpuUtilization = source.CpuUtilization,
+        HbInterval = source.HbInterval,
+        IsDisposable = source.IsDisposable,
+        OwnerUserId = source.OwnerUserId
+      };
+    }
+    public static DA.Slave ToEntity(this DT.Slave source) {
+      if (source == null) return null;
+      var result = new DA.Slave();
+      source.CopyToEntity(result);
+      return result;
+    }
+    public static void CopyToEntity(this DT.Slave source, DA.Slave target) {
+      if ((source == null) || (target == null)) return;
+      target.ResourceId = source.Id;
+      target.ParentResourceId = source.ParentResourceId;
+      target.Cores = source.Cores;
+      target.CpuSpeed = source.CpuSpeed;
+      target.FreeCores = source.FreeCores;
+      target.FreeMemory = source.FreeMemory;
+      target.IsAllowedToCalculate = source.IsAllowedToCalculate;
+      target.Memory = source.Memory;
+      target.Name = source.Name;
+      target.SlaveState = source.SlaveState.ToEntity();
+      target.CpuArchitecture = source.CpuArchitecture.ToEntity();
+      target.OperatingSystem = source.OperatingSystem;
+      target.LastHeartbeat = source.LastHeartbeat;
+      target.CpuUtilization = source.CpuUtilization;
+      target.HbInterval = source.HbInterval;
+      target.IsDisposable = source.IsDisposable;
+      target.OwnerUserId = source.OwnerUserId;
+    }
+    #endregion
+
     #region State
     public static DT.TaskState ToDto(this DA.TaskState source) {
@@ -206,4 +257,146 @@
     #endregion
 
+    #region Plugin
+    public static DT.Plugin ToDto(this DA.Plugin source) {
+      if (source == null) return null;
+      return new DT.Plugin {
+        Id = source.PluginId,
+        Name = source.Name,
+        Version = new Version(source.Version),
+        UserId = source.UserId,
+        DateCreated = source.DateCreated,
+        Hash = source.Hash
+      };
+    }
+    public static DA.Plugin ToEntity(this DT.Plugin source) {
+      if (source == null) return null;
+      var result = new DA.Plugin();
+      source.CopyToEntity(result);
+      return result;
+    }
+    public static void CopyToEntity(this DT.Plugin source, DA.Plugin target) {
+      if ((source == null) || (target == null)) return;
+      target.PluginId = source.Id;
+      target.Name = source.Name;
+      target.Version = source.Version.ToString();
+      target.UserId = source.UserId;
+      target.DateCreated = source.DateCreated;
+      target.Hash = source.Hash;
+    }
+    #endregion
+
+    #region PluginData
+    public static DT.PluginData ToDto(this DA.PluginData source) {
+      if (source == null) return null;
+      return new DT.PluginData {
+        Id = source.PluginDataId,
+        PluginId = source.PluginId,
+        Data = source.Data.ToArray(),
+        FileName = source.FileName
+      };
+    }
+
+    public static DA.PluginData ToEntity(this DT.PluginData source) {
+      if (source == null) return null;
+      var result = new DA.PluginData();
+      source.CopyToEntity(result);
+      return result;
+    }
+
+    public static void CopyToEntity(this DT.PluginData source, DA.PluginData target) {
+      if ((source == null) || (target == null)) return;
+      target.PluginDataId = source.Id;
+      target.PluginId = source.PluginId;
+      target.Data = source.Data;
+      target.FileName = source.FileName;
+    }
+    #endregion
+
+    #region ResourcePermission
+    public static DT.ResourcePermission ToDto(this DA.ResourcePermission source) {
+      if (source == null) return null;
+      return new DT.ResourcePermission {
+        ResourceId = source.ResourceId,
+        GrantedUserId = source.GrantedUserId,
+        GrantedByUserId = source.GrantedByUserId
+      };
+    }
+    public static DA.ResourcePermission ToEntity(this DT.ResourcePermission source) {
+      if (source == null) return null;
+      var result = new DA.ResourcePermission();
+      source.CopyToEntity(result);
+      return result;
+    }
+    public static void CopyToEntity(this DT.ResourcePermission source, DA.ResourcePermission target) {
+      if ((source == null) || (target == null)) return;
+      target.ResourceId = source.ResourceId;
+      target.GrantedUserId = source.GrantedUserId;
+      target.GrantedByUserId = source.GrantedByUserId;
+    }
+    #endregion
+
+    #region SlaveGroup
+    public static DT.SlaveGroup ToDto(this DA.SlaveGroup source) {
+      if (source == null) return null;
+      return new DT.SlaveGroup {
+        Id = source.ResourceId,
+        Name = source.Name,
+        ParentResourceId = source.ParentResourceId,
+        HbInterval = source.HbInterval,
+        OwnerUserId = source.OwnerUserId
+      };
+    }
+
+    public static DA.SlaveGroup ToEntity(this DT.SlaveGroup source) {
+      if (source == null) return null;
+      var result = new DA.SlaveGroup();
+      source.CopyToEntity(result);
+      return result;
+    }
+
+    public static void CopyToEntity(this DT.SlaveGroup source, DA.SlaveGroup target) {
+      if ((source == null) || (target == null)) return;
+      target.ResourceId = source.Id;
+      target.Name = source.Name;
+      target.ParentResourceId = source.ParentResourceId;
+      target.HbInterval = source.HbInterval;
+      target.OwnerUserId = source.OwnerUserId;
+    }
+    #endregion
+
+    #region Downtimes
+    public static DT.Downtime ToDto(this DA.Downtime source) {
+      if (source == null) return null;
+      return new DT.Downtime {
+        Id = source.DowntimeId,
+        AllDayEvent = source.AllDayEvent,
+        EndDate = source.EndDate,
+        Recurring = source.Recurring,
+        RecurringId = source.RecurringId,
+        ResourceId = source.ResourceId,
+        StartDate = source.StartDate,
+        DowntimeType = source.DowntimeType
+      };
+    }
+    public static DA.Downtime ToEntity(this DT.Downtime source) {
+      if (source == null) return null;
+      var result = new DA.Downtime();
+      source.CopyToEntity(result);
+      return result;
+    }
+    public static void CopyToEntity(this DT.Downtime source, DA.Downtime target) {
+      if ((source == null) || (target == null)) return;
+      target.DowntimeId = source.Id;
+      target.AllDayEvent = source.AllDayEvent;
+      target.EndDate = source.EndDate;
+      target.Recurring = source.Recurring;
+      target.RecurringId = source.RecurringId;
+      target.ResourceId = source.ResourceId;
+      target.StartDate = source.StartDate;
+      target.DowntimeType = source.DowntimeType;
+    }
+    #endregion
+
+
     #region Command
     public static DT.Command? ToDto(this DA.Command? source) {
@@ -252,4 +445,63 @@
     #endregion
 
+    #region CpuArchiteture
+    public static DT.CpuArchitecture ToDto(this DA.CpuArchitecture source) {
+      switch (source) {
+        case DA.CpuArchitecture.x64: return DT.CpuArchitecture.x64;
+        case DA.CpuArchitecture.x86: return DT.CpuArchitecture.x86;
+        default: return DT.CpuArchitecture.x86;
+      }
+    }
+
+    public static DA.CpuArchitecture ToEntity(this DT.CpuArchitecture source) {
+      switch (source) {
+        case DT.CpuArchitecture.x64: return DA.CpuArchitecture.x64;
+        case DT.CpuArchitecture.x86: return DA.CpuArchitecture.x86;
+        default: return DA.CpuArchitecture.x86;
+      }
+    }
+    #endregion
+
+    #region SlaveState
+    public static DT.SlaveState ToDto(this DA.SlaveState source) {
+      switch (source) {
+        case DA.SlaveState.Calculating: return DT.SlaveState.Calculating;
+        case DA.SlaveState.Idle: return DT.SlaveState.Idle;
+        case DA.SlaveState.Offline: return DT.SlaveState.Offline;
+        default: return DT.SlaveState.Offline;
+      }
+    }
+
+    public static DA.SlaveState ToEntity(this DT.SlaveState source) {
+      switch (source) {
+        case DT.SlaveState.Calculating: return DA.SlaveState.Calculating;
+        case DT.SlaveState.Idle: return DA.SlaveState.Idle;
+        case DT.SlaveState.Offline: return DA.SlaveState.Offline;
+        default: return DA.SlaveState.Offline;
+      }
+    }
+    #endregion
+
+    #region UserPriority
+    public static DT.UserPriority ToDto(this DA.UserPriority source) {
+      if (source == null) return null;
+      return new DT.UserPriority() {
+        Id = source.UserId,
+        DateEnqueued = source.DateEnqueued
+      };
+    }
+    public static DA.UserPriority ToEntity(this DT.UserPriority source) {
+      if (source == null) return null;
+      var result = new DA.UserPriority();
+      source.CopyToEntity(result);
+      return result;
+    }
+    public static void CopyToEntity(this DT.UserPriority source, DA.UserPriority target) {
+      if ((source == null) || (target == null)) return;
+      target.UserId = source.Id;
+      target.DateEnqueued = source.DateEnqueued;
+    }
+    #endregion
+
   }
 }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HeuristicLab.Services.Hive-3.3.csproj
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HeuristicLab.Services.Hive-3.3.csproj	(revision 12689)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HeuristicLab.Services.Hive-3.3.csproj	(revision 12691)
@@ -146,4 +146,5 @@
     <Compile Include="HiveStatisticsGenerator.cs" />
     <Compile Include="Interfaces\IStatisticsGenerator.cs" />
+    <Compile Include="Manager\NewHeartbeatManager.cs" />
     <Compile Include="NewHiveService.cs" />
     <Compile Include="OptimizedHiveDao.cs" />
@@ -154,4 +155,6 @@
     <Compile Include="Interfaces\IHiveDao.cs" />
     <Compile Include="Interfaces\ITaskScheduler.cs" />
+    <Compile Include="PerformanceLogger.cs" />
+    <Compile Include="Scheduler\NewRoundRobinTaskScheduler.cs" />
     <Compile Include="Scheduler\TaskInfoForScheduler.cs" />
     <Compile Include="Scheduler\JobInfoForScheduler.cs" />
